use std::error::Error;
use std::thread;
use std::time::Duration;
use enigo::{Enigo, MouseControllable};

fn main() -> Result<(), Box<dyn Error>> {
    let mut enigo = Enigo::new();
    println!("Mouse wiggler started. Press Ctrl+C to exit.");
    println!("Moving mouse every 3 minutes...");

    let mut last_x = enigo.mouse_location().0;
    let mut last_y = enigo.mouse_location().1;
    let move_distance = 1;

    loop {
        thread::sleep(Duration::from_secs(180));

        let (current_x, current_y) = enigo.mouse_location();

        if current_x == last_x && current_y == last_y {
            enigo.mouse_move_to(current_x + move_distance, current_y);
            thread::sleep(Duration::from_millis(100));
            enigo.mouse_move_to(current_x + move_distance, current_y + move_distance);
            thread::sleep(Duration::from_millis(100));
            enigo.mouse_move_to(current_x, current_y + move_distance);
            thread::sleep(Duration::from_millis(100));
            enigo.mouse_move_to(current_x, current_y);

            println!("Mouse moved at: {:?}", chrono::Local::now());
        }

        last_x = enigo.mouse_location().0;
        last_y = enigo.mouse_location().1;
    }
}
